diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
index 9ea666060..7e1f912c4 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -19,10 +19,50 @@ public class AchievementPages {
         if (hasInit) return;
         hasInit = true;
         overworldPage = register(new AchievementPageOverworld("gui.achievements.page.overworld", Blocks.GRASS.getDefaultStack()));
+        overworldPage.addAchievement(Achievements.OPEN_INVENTORY, 0, 0);
+        overworldPage.addAchievement(Achievements.MINE_WOOD, 2, 1);
+        overworldPage.addAchievement(Achievements.BUILD_WORKBENCH, 4, -1);
+        overworldPage.addAchievement(Achievements.BUILD_PICKAXE, 4, 2);
+        overworldPage.addAchievement(Achievements.BUILD_FURNACE, 3, 4);
+        overworldPage.addAchievement(Achievements.ACQUIRE_IRON, 1, 4);
+        overworldPage.addAchievement(Achievements.GET_DIAMONDS, -1, 4);
+        overworldPage.addAchievement(Achievements.BUILD_HOE, 1, -3);
+        overworldPage.addAchievement(Achievements.MAKE_BREAD, -2, -3);
+        overworldPage.addAchievement(Achievements.BAKE_CAKE, -1, -5);
+        overworldPage.addAchievement(Achievements.CRAFT_ICECREAM, 1, -6);
+        overworldPage.addAchievement(Achievements.CRAFT_PUMPKIN_PIE, -1, -1);
+        overworldPage.addAchievement(Achievements.BUILD_BETTER_PICKAXE, 6, 2);
+        overworldPage.addAchievement(Achievements.COOK_FISH, 2, 6);
+        overworldPage.addAchievement(Achievements.ON_A_RAIL, 2, 3);
+        overworldPage.addAchievement(Achievements.BUILD_SWORD, 6, -1);
+        overworldPage.addAchievement(Achievements.ALL_ARMOR_TYPES, 13, 1);
+        overworldPage.addAchievement(Achievements.KILL_ENEMY, 8, -1);
+        overworldPage.addAchievement(Achievements.KILL_COW, 7, -3);
+        overworldPage.addAchievement(Achievements.FLY_PIG, 8, -4);
+        overworldPage.addAchievement(Achievements.GET_SENSED, 9, -3);
+        overworldPage.addAchievement(Achievements.CRAFT_HANDCANNON, 8, 2);
+        overworldPage.addAchievement(Achievements.COLLECT_STONE, 5, 4);
+        overworldPage.addAchievement(Achievements.CRUSH_BLOCKS, 7, 4);
+        overworldPage.addAchievement(Achievements.REPAIR_ARMOR, 9, 0);
+        overworldPage.addAchievement(Achievements.GET_CHAINMAIL, 11, 0);
+        overworldPage.addAchievement(Achievements.OPEN_GUIDEBOOK, 0, 2);
+        overworldPage.addAchievement(Achievements.CAUGHT_EM_ALL, 4, -4);
+        overworldPage.addAchievement(Achievements.ALL_MUSIC_DISCS, -3, 4);
+        overworldPage.addAchievement(Achievements.TRIPLE_HIT, 11, -2);
+
         netherPage = register(new AchievementPageNether("gui.achievements.page.nether", Blocks.COBBLE_NETHERRACK.getDefaultStack()));
+        netherPage.addAchievement(Achievements.ENTER_NETHER, 2, 0);
+        netherPage.addAchievement(Achievements.GET_NETHERCOAL, 1, 2);
+        netherPage.addAchievement(Achievements.LIGHT_SIGN, 4, 0);
+        netherPage.addAchievement(Achievements.SWIM_NETHER, 3, 2);
+        netherPage.addAchievement(Achievements.HIT_FIREBALL, 3, -2);
+        netherPage.addAchievement(Achievements.SLEEP_NETHER, 1, -2);
+        netherPage.addAchievement(Achievements.ENTER_OLDWORLD, 0, -5);
+        netherPage.addAchievement(Achievements.ENTER_WARRENS, 0, 5);
+        netherPage.addAchievement(Achievements.MOST_WANTED, 0, -1);
+        netherPage.addAchievement(Achievements.FAST_TRAVEL, 0, 1);
     }
     static {
-        Achievements.init();
         init();
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java b/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
index 2a97efc55..58d99ad0a 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
@@ -12,6 +12,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.Objects;
 import java.util.Random;
 
 public class AchievementPageNether extends AchievementPage {
@@ -36,8 +37,8 @@ public class AchievementPageNether extends AchievementPage {
     }
 
     @Override
-    public @NotNull Achievement onOpenAchievement() {
-        return Achievements.ENTER_NETHER;
+    public @NotNull AchievementEntry onOpenAchievement() {
+        return Objects.requireNonNull(getEntry(Achievements.ENTER_NETHER));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java b/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
index 8d5edbd90..242718d51 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
@@ -16,6 +16,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Objects;
 import java.util.Random;
 import java.util.function.BiFunction;
 
@@ -41,8 +42,8 @@ public class AchievementPageOverworld extends AchievementPage {
     }
 
     @Override
-    public @NotNull Achievement onOpenAchievement() {
-        return Achievements.BUILD_WORKBENCH;
+    public @NotNull AchievementEntry onOpenAchievement() {
+        return Objects.requireNonNull(getEntry(Achievements.BUILD_WORKBENCH));
     }
 
     protected static final int ORE_COAL = 0;
diff --git a/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index 9607f5302..f5b571bcf 100644
--- a/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -87,7 +87,7 @@ public class GuiElementChatSuggestions extends Gui {
     }
 
     public CommandManager getManager() {
-        return this.mc.theWorld == null ? new CommandManager(false) : mc.theWorld.getCommandManager();
+        return this.mc.currentWorld == null ? new CommandManager(false) : mc.currentWorld.getCommandManager();
     }
 
     public void drawScreen() {
diff --git a/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index 3c4c59b61..5eba67777 100644
--- a/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -411,7 +411,7 @@ public class ScreenFlagEditor
         if (eventKey == Keyboard.KEY_ESCAPE || mc.gameSettings.keyInventory.isKeyboardKey(eventKey) || eventKey == Keyboard.KEY_BACK)
         {
     		// Flag packet needs to be sent before the close screen packet is sent!
-    		if(mc.theWorld.isClientSide) {
+    		if(mc.currentWorld.isClientSide) {
     			mc.getSendQueue().addToSendQueue(new CustomPayloadPacket("BTA|Flag", flagEntity.flagColors));
     		}
             mc.thePlayer.closeScreen();
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index e823a6423..a9dcc739f 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -231,7 +231,7 @@ public class GuidebookPageMob
                 if (livingSound != null) {
                     Minecraft mc = Minecraft.getMinecraft(this);
                     Random random = new Random();
-                    mc.theWorld.playSoundAtEntity(null, mc.thePlayer, livingSound, 0.25f, (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
+                    mc.currentWorld.playSoundAtEntity(null, mc.thePlayer, livingSound, 0.25f, (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index bb33b137b..77c914c5e 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -106,7 +106,7 @@ public class HudIngame extends Gui
 
         // Render pumpkin overlay
         ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
-        if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id)
+        if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id))
         {
             renderPumpkinBlur(width, height);
         }
@@ -299,19 +299,19 @@ public class HudIngame extends Gui
                     int playerX = MathHelper.floor(mc.thePlayer.x);
                     int playerY = MathHelper.floor(mc.thePlayer.y);
                     int playerZ = MathHelper.floor(mc.thePlayer.z);
-                    drawDebugScreenLine("Light: Sky: " + mc.theWorld.getSavedLightValue(LightLayer.Sky, playerX, playerY, playerZ) + " Block: " + mc.theWorld.getSavedLightValue(LightLayer.Block, playerX, playerY, playerZ));
+                    drawDebugScreenLine("Light: Sky: " + mc.currentWorld.getSavedLightValue(LightLayer.Sky, playerX, playerY, playerZ) + " Block: " + mc.currentWorld.getSavedLightValue(LightLayer.Block, playerX, playerY, playerZ));
                 }
 
                 debugOffset += space;
 
-                drawDebugScreenLine("Entities: " + mc.theWorld.getLoadedEntityList().size());
-                drawDebugScreenLine("Block Entities: " + mc.theWorld.getLoadedBlockEntityList().size());
+                drawDebugScreenLine("Entities: " + mc.currentWorld.getLoadedEntityList().size());
+                drawDebugScreenLine("Block Entities: " + mc.currentWorld.getLoadedBlockEntityList().size());
 
                 debugOffset += space;
 
                 if (clock)
                 {
-                    drawDebugScreenLine("Time: " + getTimeString() + " (Day " + (mc.theWorld.getWorldTime() / Global.DAY_LENGTH_TICKS) + ")");
+                    drawDebugScreenLine("Time: " + getTimeString() + " (Day " + (mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS) + ")");
                 }
                 else
                 {
@@ -322,9 +322,9 @@ public class HudIngame extends Gui
 
                 if (rotaryCalendar)
                 {
-                    Season season = mc.theWorld.getSeasonManager().getCurrentSeason();
+                    Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
                     String seasonString = season != null ? season.getTranslatedName() : "None";
-                    Weather weather = mc.theWorld.getCurrentWeather();
+                    Weather weather = mc.currentWorld.getCurrentWeather();
                     String weatherString = weather != null ? weather.getTranslatedName() : "None";
                     
                     int blockX = MathHelper.floor(mc.thePlayer.x);
@@ -332,18 +332,18 @@ public class HudIngame extends Gui
 					int blockZ = MathHelper.floor(mc.thePlayer.z);
                     
                     drawDebugScreenLine("Season: " + seasonString);
-                    drawDebugScreenLine("Weather: " + weatherString + " (" + (mc.theWorld.weatherManager.getWeatherDuration() / 20) + "s I: " + percentRound(mc.theWorld.weatherManager.getWeatherIntensity()) + "% P: " + percentRound(mc.theWorld.weatherManager.getWeatherPower()) + "%)");
-                    drawDebugScreenLine("Biome: " + Registries.BIOMES.getKey(mc.theWorld.getBlockBiome(blockX, blockY, blockZ)));
+                    drawDebugScreenLine("Weather: " + weatherString + " (" + (mc.currentWorld.weatherManager.getWeatherDuration() / 20) + "s I: " + percentRound(mc.currentWorld.weatherManager.getWeatherIntensity()) + "% P: " + percentRound(mc.currentWorld.weatherManager.getWeatherPower()) + "%)");
+                    drawDebugScreenLine("Biome: " + Registries.BIOMES.getKey(mc.currentWorld.getBlockBiome(blockX, blockY, blockZ)));
                     
-                    float temperature = (float) floor100(mc.theWorld.getBlockTemperature(blockX, blockZ));
-                    float humidity = (float) floor100(mc.theWorld.getBlockHumidity(blockX, blockZ));
+                    float temperature = (float) floor100(mc.currentWorld.getBlockTemperature(blockX, blockZ));
+                    float humidity = (float) floor100(mc.currentWorld.getBlockHumidity(blockX, blockZ));
                     
                     drawDebugScreenLine("Temperature: " + temperature + " Humidity: " + humidity);
                     
-                    WindProvider windProvider = mc.theWorld.worldType.getWindManager();
+                    WindProvider windProvider = mc.currentWorld.worldType.getWindManager();
                     if(windProvider != null) {
-                    	float direction = (float) floor100(windProvider.getWindDirection(mc.theWorld, 0.0f, 500.0f, 0.0f));
-                    	float intensity = (float) floor100(windProvider.getWindIntensity(mc.theWorld, 0.0f, 500.0f, 0.0f));
+                    	float direction = (float) floor100(windProvider.getWindDirection(mc.currentWorld, 0.0f, 500.0f, 0.0f));
+                    	float intensity = (float) floor100(windProvider.getWindIntensity(mc.currentWorld, 0.0f, 500.0f, 0.0f));
 
                         int yaw = DynamicTexture.pmod(java.lang.Math.round((direction * 360.0f) + 270.0f), 360);
                     	drawDebugScreenLine("Wind: " + yaw + "°, " + java.lang.Math.round(intensity * 100.0f) + "%");
@@ -356,7 +356,7 @@ public class HudIngame extends Gui
 
                 debugOffset += space;
 
-                drawDebugScreenLine("Seed: " + mc.theWorld.getRandomSeed());
+                drawDebugScreenLine("Seed: " + mc.currentWorld.getRandomSeed());
 
                 debugOffset += space;
 
@@ -367,13 +367,13 @@ public class HudIngame extends Gui
                 {
                     debugOffset += space;
 
-                    Block block = Block.blocksList[mc.theWorld.getBlockId(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z)];
+                    Block block = Block.blocksList[mc.currentWorld.getBlockId(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z)];
                     if (block.id > 0 && block.id < Block.blocksList.length)
                     {
                         drawDebugScreenLineRight("Looking at:");
 
                         String name;
-                        int meta = mc.theWorld.getBlockMetadata(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z);
+                        int meta = mc.currentWorld.getBlockMetadata(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z);
                         try
                         {
                             name = block.asItem().getTranslatedName(new ItemStack(block, 1, meta));
@@ -406,11 +406,11 @@ public class HudIngame extends Gui
                             lightY += side.getOffsetY();
                             lightZ += side.getOffsetZ();
 
-                            drawDebugScreenLineRight("Light: Sky: " + mc.theWorld.getSavedLightValue(LightLayer.Sky, lightX, lightY, lightZ) + " Block: " + mc.theWorld.getSavedLightValue(LightLayer.Block, lightX, lightY, lightZ));
+                            drawDebugScreenLineRight("Light: Sky: " + mc.currentWorld.getSavedLightValue(LightLayer.Sky, lightX, lightY, lightZ) + " Block: " + mc.currentWorld.getSavedLightValue(LightLayer.Block, lightX, lightY, lightZ));
                         }
 
-                        drawDebugScreenLineRight("Signal: " + mc.theWorld.getSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
-                        drawDebugScreenLineRight("Direct signal: " + mc.theWorld.getDirectSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
+                        drawDebugScreenLineRight("Signal: " + mc.currentWorld.getSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
+                        drawDebugScreenLineRight("Direct signal: " + mc.currentWorld.getDirectSignal(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z, mc.objectMouseOver.side));
 
                         for (Tag<Block> tag : BlockTags.TAG_LIST)
                         {
@@ -472,12 +472,12 @@ public class HudIngame extends Gui
                     {
                         if (mc.gameSettings.overlayMode.value == 0)
                         {
-                            this.drawString(font, String.format("%s %s %d", getTimeString(), I18n.getInstance().translateKey("unit.day"),mc.theWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawString(font, String.format("%s %s %d", getTimeString(), I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
                         }
                         if (mc.gameSettings.overlayMode.value > 0)
                         {
                             this.drawString(font, getTimeString(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
-                            this.drawString(font, String.format("%s %d", I18n.getInstance().translateKey("unit.day"),mc.theWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawString(font, String.format("%s %d", I18n.getInstance().translateKey("unit.day"),mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
                         }
                     }
                 }
@@ -485,7 +485,7 @@ public class HudIngame extends Gui
                 {
                     if (mc.gameSettings.overlayShowSeason.value)
                     {
-                        Season season = mc.theWorld.getSeasonManager().getCurrentSeason();
+                        Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
                         if (season != null)
                         {
                             this.drawString(font, season.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0x80ffff : 0xffffff);
@@ -493,8 +493,8 @@ public class HudIngame extends Gui
                     }
                     if (mc.gameSettings.overlayShowWeather.value)
                     {
-                        Weather weather = mc.theWorld.getCurrentWeather();
-                        if (weather != null && weather != mc.theWorld.worldType.getDefaultWeather())
+                        Weather weather = mc.currentWorld.getCurrentWeather();
+                        if (weather != null && weather != mc.currentWorld.worldType.getDefaultWeather())
                         {
                             this.drawString(font, weather.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
                         }
@@ -504,7 +504,7 @@ public class HudIngame extends Gui
 						int blockX = MathHelper.floor(mc.thePlayer.x);
 						int blockY = MathHelper.floor(mc.thePlayer.y);
 						int blockZ = MathHelper.floor(mc.thePlayer.z);
-						String key = mc.theWorld.getBlockBiome(blockX, blockY, blockZ).translationKey;
+						String key = mc.currentWorld.getBlockBiome(blockX, blockY, blockZ).translationKey;
 						drawString(font, stringtranslate.translateKey(key), tsp, tsp + lineHeight * line++, 0xffffff);
 					}
                 }
@@ -864,7 +864,7 @@ public class HudIngame extends Gui
 
     public String getTimeString()
     {
-        long worldTime = mc.theWorld.getWorldTime();
+        long worldTime = mc.currentWorld.getWorldTime();
         int dayLength = Global.DAY_LENGTH_TICKS;
         int dayTime = (int) (worldTime % dayLength);
 
diff --git a/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java b/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
index 38b191ee7..933ebb698 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
@@ -47,7 +47,7 @@ public class HudIngameDoom
 
         // Render pumpkin overlay
         ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
-        if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id)
+        if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id))
         {
             renderPumpkinBlur(width, height);
         }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index e25a8e13a..1a3b3dd61 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -50,7 +50,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         String name = "None";
         if (displayBlock != null){
             name = I18n.getInstance().translateNameKey(displayBlock.getKey());
-            ItemStack[] nameStack = displayBlock.getBreakResult(mc.theWorld, EnumDropCause.PICK_BLOCK, DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ, DisplayChunk.displayBlockMeta, DisplayChunk.displayTileEntity);
+            ItemStack[] nameStack = displayBlock.getBreakResult(mc.currentWorld, EnumDropCause.PICK_BLOCK, DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ, DisplayChunk.displayBlockMeta, DisplayChunk.displayTileEntity);
             if (nameStack != null && nameStack.length > 0){
                 name = nameStack[0].getDisplayName();
             }
@@ -134,7 +134,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
 
         if (entry != null){
-            List<ButtonElement> list = entry.getEntryButtons(mc, modelViewer, mc.theWorld, DisplayChunk.displayBlockMeta);
+            List<ButtonElement> list = entry.getEntryButtons(mc, modelViewer, mc.currentWorld, DisplayChunk.displayBlockMeta);
             if (list != null){
                 for (ButtonElement button : list) {
                     button.setX(button.getX() + xPos);
@@ -164,10 +164,10 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
     public void onTick() {
         BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
         if (entry != null){
-            entry.onTick(mc.theWorld, DisplayChunk.displayBlockMeta);
+            entry.onTick(mc.currentWorld, DisplayChunk.displayBlockMeta);
         }
         // Delete any items blocks create when added/removed
-        mc.theWorld.loadedEntityList.removeIf(entity -> entity instanceof EntityItem);
+        mc.currentWorld.loadedEntityList.removeIf(entity -> entity instanceof EntityItem);
     }
     public void setDisplayBlock(int id, int meta){
         Block displayBlock = Block.blocksList[DisplayChunk.displayBlockId];
@@ -176,10 +176,10 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         int _meta = DisplayChunk.displayBlockMeta;
 
         if (displayBlock != null && _id != id){
-            displayBlock.onBlockRemoved(mc.theWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z, _meta);
+            displayBlock.onBlockRemoved(mc.currentWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z, _meta);
         }
         if (entry != null){
-            entry.onClose(mc.theWorld, DisplayChunk.displayBlockMeta);
+            entry.onClose(mc.currentWorld, DisplayChunk.displayBlockMeta);
         }
         DisplayChunk.displayBlockPosX = (int) mc.thePlayer.x;
         DisplayChunk.displayBlockPosY = (int) mc.thePlayer.y;
@@ -189,13 +189,13 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         displayBlock = Block.blocksList[id];
         if (displayBlock != null && _id != id){
             entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
-            displayBlock.onBlockPlacedByWorld(mc.theWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z);
-            if (entry != null) entry.onOpen(mc.theWorld, DisplayChunk.displayBlockMeta);
+            displayBlock.onBlockPlacedByWorld(mc.currentWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z);
+            if (entry != null) entry.onOpen(mc.currentWorld, DisplayChunk.displayBlockMeta);
         }
         if (_id != id){
             modelViewer.init();
         }
-        mc.particleEngine.setWorld(mc.theWorld);
+        mc.particleEngine.setWorld(mc.currentWorld);
         mc.renderGlobal.loadRenderers();
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
index 14b7f768d..3f18f69c2 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryEntity.java
@@ -61,7 +61,7 @@ public class ViewerCategoryEntity extends ModelViewerCategory{
         addEntry(new EntityEntryPainting());
     }
     public void addEntry(EntityEntry<?> entry){
-        Entity entity = entry.getEntityInstance(mc, mc.theWorld);
+        Entity entity = entry.getEntityInstance(mc, mc.currentWorld);
         if (entity == null) return;
         EntityEntry<?> oldEntry = entryMap.put(entity.getClass(), entry);
         entryList.remove(oldEntry);
@@ -146,14 +146,14 @@ public class ViewerCategoryEntity extends ModelViewerCategory{
         currentEntry = _val.get((id + _val.size() + offset) % _val.size());
         currentEntry.onOpen();
 
-        setDisplayEntity(currentEntry.getEntityInstance(mc, mc.theWorld));
+        setDisplayEntity(currentEntry.getEntityInstance(mc, mc.currentWorld));
     }
 
     @Override
     public void onOpen() {
         currentEntry = entryMap.get(MobZombie.class);
         currentEntry.onOpen();
-        setDisplayEntity(currentEntry.getEntityInstance(mc, mc.theWorld));
+        setDisplayEntity(currentEntry.getEntityInstance(mc, mc.currentWorld));
     }
 
     @Override
@@ -185,19 +185,19 @@ public class ViewerCategoryEntity extends ModelViewerCategory{
 
             displayEntity.absMoveTo(mc.thePlayer.x, mc.thePlayer.y - displayEntity.bbHeight/2, mc.thePlayer.z, displayEntity.yRot, displayEntity.xRot);
             displayEntity.lerpMotion(0, 0, 0);
-            mc.theWorld.entityJoinedWorld(displayEntity);
+            mc.currentWorld.entityJoinedWorld(displayEntity);
             if (displayEntity instanceof Mob){
                 ((Mob) displayEntity).setSkinVariant(0);
             }
         }
-        mc.particleEngine.setWorld(mc.theWorld);
+        mc.particleEngine.setWorld(mc.currentWorld);
         modelViewer.init();
     }
     public void removeDisplayEntity(){
         if (displayEntity != null){
             displayEntity.remove();
-            mc.theWorld.loadedEntityList.remove(displayEntity);
+            mc.currentWorld.loadedEntityList.remove(displayEntity);
         }
-        mc.particleEngine.setWorld(mc.theWorld);
+        mc.particleEngine.setWorld(mc.currentWorld);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryParticle.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryParticle.java
index 88b969c67..5aa870746 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryParticle.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryParticle.java
@@ -89,7 +89,7 @@ public class ViewerCategoryParticle extends ModelViewerCategory{
     @Override
     public void cycleCategoryEntry(int offset) {
         setCurrentEntry(entriesList.get((entriesList.indexOf(currentEntry) + entriesList.size() + offset) % entriesList.size()));
-        mc.particleEngine.setWorld(mc.theWorld);
+        mc.particleEngine.setWorld(mc.currentWorld);
         modelViewer.init();
     }
 
@@ -101,7 +101,7 @@ public class ViewerCategoryParticle extends ModelViewerCategory{
 
     @Override
     public void onClose() {
-        mc.particleEngine.setWorld(mc.theWorld);
+        mc.particleEngine.setWorld(mc.currentWorld);
         currentEntry.onClose();
     }
 
@@ -111,13 +111,13 @@ public class ViewerCategoryParticle extends ModelViewerCategory{
         double offY = 0;
         double offZ = 0;
         if (spawnRadius > 0){
-            offX = mc.theWorld.rand.nextDouble() - mc.theWorld.rand.nextDouble();
-            offY = mc.theWorld.rand.nextDouble() - mc.theWorld.rand.nextDouble();
-            offZ = mc.theWorld.rand.nextDouble() - mc.theWorld.rand.nextDouble();
+            offX = mc.currentWorld.rand.nextDouble() - mc.currentWorld.rand.nextDouble();
+            offY = mc.currentWorld.rand.nextDouble() - mc.currentWorld.rand.nextDouble();
+            offZ = mc.currentWorld.rand.nextDouble() - mc.currentWorld.rand.nextDouble();
         }
         offX *= spawnRadius;
         offY *= spawnRadius;
         offZ *= spawnRadius;
-        currentEntry.spawnParticle(mc, mc.theWorld, mc.thePlayer.x + offX, mc.thePlayer.y + offY, mc.thePlayer.z + offZ);
+        currentEntry.spawnParticle(mc, mc.currentWorld, mc.thePlayer.x + offX, mc.thePlayer.y + offY, mc.thePlayer.z + offZ);
     }
 }
